unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Panel1: TPanel;
    Panel2: TPanel;
    TrackBar1: TTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TrackBar1Change(Sender: TObject);
  private
    Bmp: TBitmap;
    FDragging: Boolean;
    FDragStart: TPoint;
    FRect: TRect;

    FClipping: Boolean;
    FMoveStart: TPoint;

    FRotX, FRotY, FRotZ: integer;
  public

  end;

var
  Form1: TForm1;

implementation

uses
    iRotate, Types;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
    //  tH[^Cgݒ
    Self.Caption := ChangeFileExt(ExtractFileName(ParamStr(0)), '');
    //  hbOtO
    FDragging := false;
    //  `Rect
    FRect := Rect(0, 0, 1, 1);
    //  }EXNbvtO
    FClipping := false;
    //  obt@OBitmap쐬
    Bmp := TBitmap.Create;
    Bmp.Width := PaintBox1.Width;
    Bmp.Height := PaintBox1.Height;
    Bmp.PixelFormat := pf24bit;         //  ScanLinegp̂߂̎
    //  h~
    PaintBox1.ControlStyle := PaintBox1.ControlStyle + [csOpaque];
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    //  obt@OBitmapj
    Bmp.Free;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    //  hbOJn
    FDragging := true;
    //  hbOJnʒuL^
    FDragStart := Point(X, Y);
    //  `v
    PaintBox1.Repaint;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
    //  hbOȂ
    if FDragging then
    begin
        //  obt@OBitmapNA
        Bmp.Canvas.Brush.Color := clWhite;
        Bmp.Canvas.Brush.Style := bsSolid;
        Bmp.Canvas.FillRect(PaintBox1.ClientRect);
        //  obt@OBitmapɊiqɌ(mO)̕`Rect`
        Bmp.Canvas.Brush.Color := clBlack;
        Bmp.Canvas.Brush.Style := bsDiagCross;
        Bmp.Canvas.Rectangle(FDragStart.X, FDragStart.Y, X, Y);
        //  `v
        PaintBox1.Repaint;
    end;
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    //  hbOI
    FDragging := false;
    //  `Rectm
    FRect := Rect(FDragStart.X, FDragStart.Y, X, Y);
    //  ]p
    FRotX := 0;
    FRotY := 0;
    FRotZ := 0;
    //  `Rectobt@OBitmapɕ`
    Bmp.Canvas.Brush.Color := clWhite;
    Bmp.Canvas.Brush.Style := bsSolid;
    Bmp.Canvas.FillRect(PaintBox1.ClientRect);
    Bmp.Canvas.Rectangle(FRect);
    //  `v
    PaintBox1.Repaint;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
    //  obt@OBitmap̓e]
    BitBlt(PaintBox1.Canvas.Handle, 0, 0, PaintBox1.Width, PaintBox1.Height,
            Bmp.Canvas.Handle, 0, 0, SRCCOPY);
end;

(*
    -----------------------------------------------------------------
    ClientToScreen Rect
    -----------------------------------------------------------------
*)
function    ClientRectToScreenRect(ASrcControl: TControl): TRect;
var
    W, H: integer;
    L, T: integer;
begin
    //  IWi̕ƍ
    with ASrcControl.ClientRect do
    begin
        W := Right - Left;
        H := Bottom - Top;
    end;
    //  IWi̍
    with ASrcControl.ClientOrigin do
    begin
        L := X;
        T := Y;
    end;
    Result := Bounds(L, T, W, H);
end;

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
    ClipRect: TRect;
begin
    //  J[\߈ʒu
    ClipRect := ClientRectToScreenRect(TPanel(Sender));
    //  J[\
    ClipCursor(@ClipRect);
    //  ݈ʒuL^
    FMoveStart := Point(X, Y);
    //  NbsOtOON
    FClipping := true;
end;

procedure TForm1.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
    Rx, Ry, Rz, V: integer;
    Box: TRect;
begin
    //  NbsO]pύXȂ
    if FClipping then
    begin
        //  _̈ʒu
        V := TrackBar1.Position;
        //  XY]pύXՂ̗vȂ
        if (Sender = Panel1) then
        begin
            //  X̉]p
            Rx := FRotX + (X - FMoveStart.X) * 3;
            //  Ỷ]p
            Ry := FRotY + (Y - FMoveStart.Y) * 3;
            //  Z̉]p
            Rz := FRotZ + 0;
        end
        //  XZ]pύXՂ̗vȂ
        else if (Sender = Panel2) then
        begin
            //  X̉]p
            Rx := FRotX + (X - FMoveStart.X) * 3;
            //  Ỷ]p
            Ry := FRotY + 0;
            //  Z̉]p
            Rz := FRotZ + (Y - FMoveStart.Y) * 3;
        end
        //  ȊO肦Ȃ
        else
        begin
            //  I
            exit;
        end;
        //  360xȏ̉]ɈӖ
        Rx := Rx mod 360;
        Ry := Ry mod 360;
        Rz := Rz mod 360;
        //  obt@OBitmapNA
        Bmp.Canvas.Brush.Color := clWhite;
        Bmp.Canvas.Brush.Style := bsSolid;
        Bmp.Canvas.FillRect(PaintBox1.ClientRect);
        //  obt@OBitmapɕ`Rect]ĕ`
        Bmp.Canvas.Brush.Color := clBlue;
        DrawRotatedRect(Bmp.Canvas, FRect, Rx, Ry, Rz, V, true);
        //  obt@OBitmapɉ]ς݂̕`Rect̊ORect`
        Box := GetDegRotatedRectBox(FRect, Rx, Ry, Rz, V);
        Bmp.Canvas.FrameRect(Box);
        //  `v
        PaintBox1.Repaint;
    end;
end;

procedure TForm1.Panel1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    //  ܂ł̉]pL^
    //  XY]pύXՂ̗vȂ
    if (Sender = Panel1) then
    begin
        //  X̉]p
        Inc(FRotX, (X - FMoveStart.X) * 3);
        //  Ỷ]p
        Inc(FRotY, (Y - FMoveStart.Y) * 3);
    end
    //  XZ]pύXՂ̗vȂ
    else if (Sender = Panel2) then
    begin
        //  X̉]p
        Inc(FRotX, (X - FMoveStart.X) * 3);
        //  Z̉]p
        Inc(FRotZ, (Y - FMoveStart.Y) * 3);
    end;
    //  360xȏ̉]ɈӖ
    FRotX := FRotX mod 360;
    FRotY := FRotY mod 360;
    FRotZ := FRotZ mod 360;
    //  J[\
    ClipCursor(nil);
    //  NbsOtOOFF
    FClipping := false;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var
    V: integer;
    Box: TRect;
begin
    V := TrackBar1.Position;
    //  obt@OBitmapNA
    Bmp.Canvas.Brush.Color := clWhite;
    Bmp.Canvas.Brush.Style := bsSolid;
    Bmp.Canvas.FillRect(PaintBox1.ClientRect);
    //  obt@OBitmapɕ`Rect]ĕ`
    Bmp.Canvas.Brush.Color := clBlue;
    DrawRotatedRect(Bmp.Canvas, FRect, FRotX, FRotY, FRotZ, V, true);
    //  obt@OBitmapɉ]ς݂̕`Rect̊ORect`
    Box := GetDegRotatedRectBox(FRect, FRotX, FRotY, FRotZ, V);
    Bmp.Canvas.FrameRect(Box);
    //  `v
    PaintBox1.Repaint;
end;

end.

