(*
    ============================================================================
    EVisual Basic ɂ͂߂ẴASY
        ͐Y/Zp]_
    ERs[^摜
        cGs/I[

    [2004/03/23]    쐬Jn
    [2004/03/24]    ]EPolyLine
    ============================================================================
*)

unit iRotate;

interface

uses
    Math, Types, Graphics, Classes, SysUtils, Forms;

//  ---------------------------------------------
type
    //  3̓_
    TPoint3D = record
        X   : Extended;
        Y   : Extended;
        Z   : Extended;
    end;

    PPoint3D = ^TPoint3D;

    TPointArray = array of TPoint;
    TPoint3DArray = array of TPoint3D;

//  ---------------------------------------------
//  ϊn
function    ToString(const P: TPoint): string;   overload;
function    ToString(const P: TPoint3D): string; overload;
//  ---------------------------------------------
//  ϊn
function    Point(const P: TPoint3D): TPoint;
//  ---------------------------------------------
//  ϊn
function    RectToPoint2D(const R: TRect): TPointArray;
function    RectToPoint3D(const R: TRect): TPoint3DArray;
//  ---------------------------------------------
//  쐬n
function    Point3D(const X, Y, Z: Extended): TPoint3D; overload;
function    Point3D(const X, Y: Extended): TPoint3D;    overload;
function    Point3D(const X: Extended): TPoint3D;       overload;
function    Point3D(): TPoint3D;                        overload;
function    Point3D(const P: TPoint): TPoint3D;         overload;
//  ---------------------------------------------
//  Z
function    Plus(const P1, P2: TPoint3D): TPoint3D;
function    Minus(const P1, P2: TPoint3D): TPoint3D;
//  ---------------------------------------------
//  炷
function    MoveX(const P: TPoint3D; const X: Extended): TPoint3D;
function    MoveY(const P: TPoint3D; const Y: Extended): TPoint3D;
function    MoveZ(const P: TPoint3D; const Z: Extended): TPoint3D;
//  ---------------------------------------------
//  wʒuɓ
function    SetX(const P: TPoint3D; const X: Extended): TPoint3D;
function    SetY(const P: TPoint3D; const Y: Extended): TPoint3D;
function    SetZ(const P: TPoint3D; const Z: Extended): TPoint3D;
//  ---------------------------------------------
//  _S](Radian)
function    RotateRadX(const P, O: TPoint3D; const A: Extended): TPoint3D;
function    RotateRadY(const P, O: TPoint3D; const A: Extended): TPoint3D;
function    RotateRadZ(const P, O: TPoint3D; const A: Extended): TPoint3D;
//  ---------------------------------------------
//  _S](Degree)
function    RotateDegX(const P, O: TPoint3D; const A: Extended): TPoint3D;
function    RotateDegY(const P, O: TPoint3D; const A: Extended): TPoint3D;
function    RotateDegZ(const P, O: TPoint3D; const A: Extended): TPoint3D;
//  ---------------------------------------------
//  S(TPoint)
function    Center2D(const P: TPointArray): TPoint3D;   overload;
function    Center2D(PointList: TList): TPoint3D;       overload;   //  Item = PPoint
//  ---------------------------------------------
//  S(TPoint3D)
function    Center3D(const P: TPoint3DArray): TPoint3D; overload;
function    Center3D(PointList: TList): TPoint3D;       overload;   //  Item = PPoint3D
//  ---------------------------------------------
//  S(TRect)
function    CenterOfRect(const R: TRect): TPoint3D;

//  ---------------------------------------------
//  _ł
procedure   DrawPoint(C: TCanvas; const A: TPoint; const Size: integer = 1);     overload;
procedure   DrawPoint(C: TCanvas; const X, Y: integer; const Size: integer = 1); overload;
procedure   DrawPoint(C: TCanvas; const A: TPoint3D; const Size: integer = 1);   overload;
//  ---------------------------------------------
//  Ђ
procedure   DrawLine(C: TCanvas; const A: TPoint; const B: TPoint);     overload;
procedure   DrawLine(C: TCanvas; const A: TPoint3D; const B: TPoint);   overload;
procedure   DrawLine(C: TCanvas; const A: TPoint3D; const B: TPoint3D); overload;
//  ---------------------------------------------
//  Ȃ
procedure   Polydraw2D(C: TCanvas; const P: TPointArray; const Fill: Boolean);   overload;
procedure   Polydraw2D(C: TCanvas; PointList: TList; const Fill: Boolean);       overload;
procedure   Polydraw3D(C: TCanvas; const P: TPoint3DArray; const Fill: Boolean); overload;
procedure   Polydraw3D(C: TCanvas; PointList: TList; const Fill: Boolean);       overload;

//  ---------------------------------------------
//  XYʂւ̓ϊ
function    PerspectXY(const P, V: TPoint3D): TPoint3D;

//  ---------------------------------------------
//  TRect̒Sɉ]XYʂɓ˂}`̊ORect
function    GetRadRotatedRectBox(const R: TRect; const X, Y, Z, V: Extended): TRect;
function    GetDegRotatedRectBox(const R: TRect; const X, Y, Z, V: Extended): TRect;

//  ---------------------------------------------
//  TRect̒Sɉ]XYʂɓ˂}`
procedure   DrawRotatedRect(C: TCanvas; const R: TRect; const X, Y, Z, V: Extended; const Fill: Boolean);

//  ---------------------------------------------
implementation

//  ---------------------------------------------
//  ϊn
function    ToString(const P: TPoint): string;
begin
    Result := Format('X=%3d / Y=%3d', [P.X, P.Y]);
end;

function    ToString(const P: TPoint3D): string;
begin
    Result := Format('X=%3f / Y=%3f / Z=%3f', [P.X, P.Y, P.Z]);
end;

//  ---------------------------------------------
//  ϊn
function    Point(const P: TPoint3D): TPoint;
begin
    Result := Types.Point(Round(P.X), Round(P.Y));
end;

//  ---------------------------------------------
//  ϊn
function    RectToPoint2D(const R: TRect): TPointArray;
begin
    SetLength(Result, 4);
    Result[0] := Types.Point(R.Left, R.Top);
    Result[1] := Types.Point(R.Left, R.Bottom);
    Result[2] := Types.Point(R.Right, R.Bottom);
    Result[3] := Types.Point(R.Right, R.Top);
end;

function    RectToPoint3D(const R: TRect): TPoint3DArray;
begin
    SetLength(Result, 4);
    Result[0] := Point3D(R.Left, R.Top);
    Result[1] := Point3D(R.Left, R.Bottom);
    Result[2] := Point3D(R.Right, R.Bottom);
    Result[3] := Point3D(R.Right, R.Top);
end;

//  ---------------------------------------------
//  쐬n
function    Point3D(const X, Y, Z: Extended): TPoint3D;
begin
    Result.X := X;
    Result.Y := Y;
    Result.Z := Z;
end;

function    Point3D(const X, Y: Extended): TPoint3D;
begin
    Result := Point3D(X, Y, 0);
end;

function    Point3D(const X: Extended): TPoint3D;
begin
    Result := Point3D(X, 0, 0);
end;

function    Point3D(): TPoint3D;
begin
    Result := Point3D(0, 0, 0);
end;

function    Point3D(const P: TPoint): TPoint3D;
begin
    Result := Point3D(P.X, P.Y, 0);
end;

//  ---------------------------------------------
//  Z
function    Plus(const P1, P2: TPoint3D): TPoint3D;
begin
    Result.X := P1.X + P2.X;
    Result.Y := P1.Y + P2.Y;
    Result.Z := P1.Z + P2.Z;
end;

function    Minus(const P1, P2: TPoint3D): TPoint3D;
begin
    Result.X := P1.X - P2.X;
    Result.Y := P1.Y - P2.Y;
    Result.Z := P1.Z - P2.Z;
end;

//  ---------------------------------------------
//  炷
function    MoveX(const P: TPoint3D; const X: Extended): TPoint3D;
begin
    Result := P;
    Result.X := Result.X + X;
end;

function    MoveY(const P: TPoint3D; const Y: Extended): TPoint3D;
begin
    Result := P;
    Result.Y := Result.Y + Y;
end;

function    MoveZ(const P: TPoint3D; const Z: Extended): TPoint3D;
begin
    Result := P;
    Result.Z := Result.Z + Z;
end;

//  ---------------------------------------------
//  wʒuɓ
function    SetX(const P: TPoint3D; const X: Extended): TPoint3D;
begin
    Result := P;
    Result.X := X;
end;

function    SetY(const P: TPoint3D; const Y: Extended): TPoint3D;
begin
    Result := P;
    Result.Y := Y;
end;

function    SetZ(const P: TPoint3D; const Z: Extended): TPoint3D;
begin
    Result := P;
    Result.Z := Z;
end;

//  ---------------------------------------------
//  ](Radian)
function    RotateRadX(const P, O: TPoint3D; const A: Extended): TPoint3D;
var
    Sin, Cos: Extended;
    P1, P2: TPoint3D;
begin
    SinCos(A, Sin, Cos);
    P1 := Minus(P, O);
    P2.X := P1.X;
    P2.Y := P1.Y * Cos - P1.Z * Sin;
    P2.Z := P1.Y * Sin + P1.Z * Cos;
    Result := Plus(P2, O);
end;

function    RotateRadY(const P, O: TPoint3D; const A: Extended): TPoint3D;
var
    Sin, Cos: Extended;
    P1, P2: TPoint3D;
begin
    SinCos(A, Sin, Cos);
    P1 := Minus(P, O);
    P2.X :=   P1.X * Cos + P1.Z * Sin;
    P2.Y :=   P1.Y;
    P2.Z := - P1.X * Sin + P1.Z * Cos;
    Result := Plus(P2, O);
end;

function    RotateRadZ(const P, O: TPoint3D; const A: Extended): TPoint3D;
var
    Sin, Cos: Extended;
    P1, P2: TPoint3D;
begin
    SinCos(A, Sin, Cos);
    P1 := Minus(P, O);
    P2.X := P1.X * Cos - P1.Y * Sin;
    P2.Y := P1.X * Sin + P1.Y * Cos;
    P2.Z := P1.Z;
    Result := Plus(P2, O);
end;

//  ---------------------------------------------
//  ](Degree)
function    RotateDegX(const P, O: TPoint3D; const A: Extended): TPoint3D;
begin
    Result := RotateRadX(P, O, DegToRad(A));
end;

function    RotateDegY(const P, O: TPoint3D; const A: Extended): TPoint3D;
begin
    Result := RotateRadY(P, O, DegToRad(A));
end;

function    RotateDegZ(const P, O: TPoint3D; const A: Extended): TPoint3D;
begin
    Result := RotateRadZ(P, O, DegToRad(A));
end;

//  ---------------------------------------------
//  XYʂւ̓ϊ
function    PerspectXY(const P, V: TPoint3D): TPoint3D;
var
    M, N: Extended;
begin
    if P.Z <> 0 then
    begin
        M := 1 + P.Z / V.Z;
        N := 1 + V.Z / P.Z;
        Result.X := P.X / M + V.X / N;
        Result.Y := P.Y / M + V.Y / N;
    end
    else
    begin
        Result.X := P.X;
        Result.Y := P.Y;
    end;
    Result.Z := 0;
end;


//  ---------------------------------------------
//  S(TPoint)
function    Center2D(const P: TPointArray): TPoint3D;
var
    i, Len: integer;
    X, Y: array of double;
begin
    Len := Length(P);
    SetLength(X, Len);
    SetLength(Y, Len);
    for i := 0 to Len - 1 do
    begin
        X[i] := P[i].X;
        Y[i] := P[i].Y;
    end;
    Result.X := Mean(X);
    Result.Y := Mean(Y);
    Result.Z := 0;
end;

function    Center2D(PointList: TList): TPoint3D;
var
    P: TPoint;
    i, Len: integer;
    X, Y: array of double;
begin
    Len := PointList.Count;
    SetLength(X, Len);
    SetLength(Y, Len);
    try
        for i := 0 to Len - 1 do
        begin
            P := (PPoint(PointList.Items[i]))^;
            X[i] := P.X;
            Y[i] := P.Y;
        end;
        Result.X := Mean(X);
        Result.Y := Mean(Y);
        Result.Z := 0;
    except
        Result := Point3D();
    end;
end;

//  ---------------------------------------------
//  S(TPoint3D)
function    Center3D(const P: TPoint3DArray): TPoint3D;
var
    i, Len: integer;
    X, Y, Z: array of double;
begin
    Len := Length(P);
    SetLength(X, Len);
    SetLength(Y, Len);
    SetLength(Z, Len);
    for i := 0 to Len - 1 do
    begin
        X[i] := P[i].X;
        Y[i] := P[i].Y;
        Z[i] := P[i].Z;
    end;
    Result.X := Mean(X);
    Result.Y := Mean(Y);
    Result.Z := Mean(Z);
end;

function    Center3D(PointList: TList): TPoint3D;
var
    P: TPoint3D;
    i, Len: integer;
    X, Y, Z: array of double;
begin
    Len := PointList.Count;
    SetLength(X, Len);
    SetLength(Y, Len);
    SetLength(Z, Len);
    try
        for i := 0 to Len - 1 do
        begin
            P := (PPoint3D(PointList.Items[i]))^;
            X[i] := P.X;
            Y[i] := P.Y;
            Z[i] := P.Z;
        end;
        Result.X := Mean(X);
        Result.Y := Mean(Y);
        Result.Z := Mean(Z);
    except
        Result := Point3D();
    end;
end;

//  ---------------------------------------------
//  S(TRect)
function    CenterOfRect(const R: TRect): TPoint3D;
begin
    Result := Center2D(RectToPoint2D(R));
end;

//  ---------------------------------------------
//  TRect̒Sɉ]XYʂɓ˂}`̊ORect
function    GetRadRotatedRectBox(const R: TRect; const X, Y, Z, V: Extended): TRect;
var
    C, Vanish: TPoint3D;
    Src, Dst: TPoint3DArray;
    i, Len: integer;
    ArrX, ArrY: array of double;
begin
    C := CenterOfRect(R);
    Vanish := C;
    Vanish.Z := V;

    Src := RectToPoint3D(R);
    Len := Length(Src);
    SetLength(Dst, Len);
    SetLength(ArrX, Len);
    SetLength(ArrY, Len);

    for i := 0 to Len - 1 do
    begin
        Dst[i] := Src[i];
        Dst[i] := RotateRadX(Dst[i], C, X);
        Dst[i] := RotateRadY(Dst[i], C, Y);
        Dst[i] := RotateRadZ(Dst[i], C, Z);
        Dst[i] := PerspectXY(Dst[i], Vanish);

        ArrX[i] := Dst[i].X;
        ArrY[i] := Dst[i].Y;
    end;

    Result := Rect(
                Trunc(MinValue(ArrX)), Trunc(MinValue(ArrY)), //  ͐؂̂
                Ceil(MaxValue(ArrX)), Ceil(MaxValue(ArrY))    //  傫͐؂グ
                );
end;

function    GetDegRotatedRectBox(const R: TRect; const X, Y, Z, V: Extended): TRect;
begin
    Result := GetRadRotatedRectBox(R, DegToRad(X), DegToRad(Y), DegToRad(Z), V);
end;

//  ---------------------------------------------
//  _ł
procedure   DrawPoint(C: TCanvas; const A: TPoint; const Size: integer = 1);
begin
    C.Rectangle(A.X - Size, A.Y - Size, A.X + Size, A.Y + Size);
end;

procedure   DrawPoint(C: TCanvas; const X, Y: integer; const Size: integer = 1);
begin
    DrawPoint(C, Types.Point(X, Y), Size);
end;

procedure   DrawPoint(C: TCanvas; const A: TPoint3D; const Size: integer = 1);
begin
    DrawPoint(C, Point(A), Size);
end;

//  ---------------------------------------------
//  Ђ
procedure   DrawLine(C: TCanvas; const A: TPoint; const B: TPoint);
begin
    C.MoveTo(A.X, A.Y);
    C.LineTo(B.X, B.Y);
end;

procedure   DrawLine(C: TCanvas; const A: TPoint3D; const B: TPoint);
begin
    DrawLine(C, Point(A), B);
end;

procedure   DrawLine(C: TCanvas; const A: TPoint3D; const B: TPoint3D);
begin
    DrawLine(C, Point(A), Point(B));
end;

//  ---------------------------------------------
//  Ȃ
procedure   _Polyline(C: TCanvas; P: TPointArray);
begin
    C.Polyline(P);
end;

procedure _Polygon(C: TCanvas; P: TPointArray);
begin
    C.Polygon(P);
end;

procedure   Polydraw2D(C: TCanvas; const P: TPointArray; const Fill: Boolean);
type
    TPolydraw = procedure(_C: TCanvas; _P: TPointArray);
const
    PolyFunc: array[Boolean] of TPolydraw = (_Polyline, _Polygon);
begin
    PolyFunc[Fill](C, P);
end;

procedure   Polydraw2D(C: TCanvas; PointList: TList; const Fill: Boolean);
var
    P: TPointArray;
    i: integer;
begin
    SetLength(P, PointList.Count);
    try
        for i := 0 to PointList.Count - 1 do
        begin
            P[i] := (PPoint(PointList.Items[i]))^;
        end;
        Polydraw2D(C, P, Fill);
    except
        ;
    end;
end;

procedure   Polydraw3D(C: TCanvas; const P: TPoint3DArray; const Fill: Boolean);
var
    P2: TPointArray;
    i: integer;
begin
    SetLength(P2, Length(P));
    for i := 0 to Length(P2) - 1 do
    begin
        P2[i] := Point(P[i]);
    end;
    Polydraw2D(C, P2, Fill);
end;

procedure   Polydraw3D(C: TCanvas; PointList: TList; const Fill: Boolean);
var
    P: TPointArray;
    i: integer;
begin
    SetLength(P, PointList.Count);
    try
        for i := 0 to PointList.Count - 1 do
        begin
            P[i] := Point((PPoint3D(PointList.Items[i]))^);
        end;
        Polydraw2D(C, P, Fill);
    except
        ;
    end;
end;

//  ---------------------------------------------
//  TRect̒Sɉ]XYʂɓ˂}`
procedure   DrawRotatedRect(C: TCanvas; const R: TRect; const X, Y, Z, V: Extended; const Fill: Boolean);
var
    Center, Vanish: TPoint3D;
    P: TPoint3DArray;
    i: integer;
begin
    SetLength(P, 0);

    //  S_
    Center := CenterOfRect(R);
    //  _
    Vanish := Center;
    Vanish.Z := V;
    //  TRect_̏Wɕϊ
    P := RectToPoint3D(R);
    //  Ō̓_ƍŏ̓_Ȃ
    SetLength(P, Length(P) + 1);
    P[Length(P) - 1] := P[0];
    //  ]
    for i := 0 to Length(P) - 1 do
    begin
        //  Xɉ]
        P[i] := RotateDegX(P[i], Center, X);
        //  Yɉ]
        P[i] := RotateDegY(P[i], Center, Y);
        //  Zɉ]
        P[i] := RotateDegZ(P[i], Center, Z);
        //  XYʂɓe
        P[i] := PerspectXY(P[i], Vanish);
    end;
    //  hԂ
    Polydraw3D(C, P, Fill);
end;

//  ---------------------------------------------
end.

